unit JDS_Form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Sockets, ScktComp;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Server: TServerSocket;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    SpeedButton1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    RadioGroup1: TRadioGroup;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientDisConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure SpeedButton1Click(Sender: TObject);
  private
    Log  : Boolean;
    Dump : Boolean;
    DCnt : Word;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  F,FD : TextFile;

implementation

{$R *.dfm}

procedure TForm1.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
Var HStr : String;
begin
  HStr:=Socket.ReceiveText;
  Memo1.Lines.Add(HStr);
  if Dump then
    Writeln(FD,HStr);
end;

procedure TForm1.ServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
Var DName: String;
    DExt : String;
begin
  if Log then begin
    Dump:=CheckBox1.Checked;
    Writeln(F,DateTimeToStr(now),': Client-Connect for ',Socket.RemoteHost);
    if Dump then begin
      Inc(DCnt);
      DExt:=ExtractFileExt(LabeledEdit3.Text);
      if Length(DExt)<>0 then
        DName:=Copy(LabeledEdit3.Text,1,Length(LabeledEdit3.Text)-Length(DExt))
      else
        DName:=LabeledEdit3.Text;
      DName:=DName+'_'+IntToStr(DCnt)+DExt;
      Writeln(F,DateTimeToStr(now),': Dump_File:',DName);
      AssignFile(FD,DName);
      Rewrite(FD);
    end;
  end
  else begin
    Dump:=False;
  end;
  LabeledEdit2.Text:=Socket.RemoteHost;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var hPort : Word;
begin
  try
    hPort:=StrToInt(LabeledEdit1.text);
  except // on EConvertError do begin
    hPort:=9100;
    LabeledEdit1.text:='9100';
  end;
  if LabeledEdit3.text<>'' then begin
    try
      AssignFile(F,LabeledEdit3.Text);
      Rewrite(F);
      Writeln(F,DateTimeToStr(now),': Server Started on Port:',IntToStr(hPort));
      Log:=True;
      DCnt:=0;
    except
      CloseFile(F);
      Log:=False;
    end;
  end
  else Log:=False;
  Server.Port:=hPort;
  Server.Open;
  BitBtn2.Enabled:=True;
  BitBtn1.Enabled:=False;
  SpeedButton1.Enabled:=False;
  LabeledEdit3.Enabled:=False;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Server.Close;
  if Log then begin
    Writeln(F,DateTimeToStr(now),': Server stopped');
    CloseFile(F);
    Log:=False;
  end;
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=False;
  SpeedButton1.Enabled:=True;
  LabeledEdit3.Enabled:=True;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ServerClientDisConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if Log then begin
    Writeln(F,DateTimeToStr(now),': Client-DisConnect for ',Socket.RemoteHost);
    if Dump then
      CloseFile(FD);
  end;
  LabeledEdit2.Text:='';
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Savedialog1.Filter:='Protokolldatei (*.log)|*.log';
  if SaveDialog1.Execute then begin
    LabeledEdit3.Text:=SaveDialog1.FileName;
  end
end;

end.
